--- nsprpub/pr/include/md/_freebsd.h.orig
+++ nsprpub/pr/include/md/_freebsd.h
@@ -37,7 +37,7 @@
 
 #include "prthread.h"
 
-#if __FreeBSD__ >= 2
+#if __FreeBSD__ >= 2 || defined(__DragonFly__)
 #include <osreldate.h>  /* for __FreeBSD_version */
 #endif
 #include <sys/syscall.h>
@@ -50,6 +50,10 @@
 #define _PR_SI_ARCHITECTURE "alpha"
 #elif defined(__sparc__)
 #define _PR_SI_ARCHITECTURE "sparc"
+#elif defined(__ia64__)
+#define _PR_SI_ARCHITECTURE "ia64"
+#elif defined(__amd64__)
+#define _PR_SI_ARCHITECTURE "amd64"
 #else
 #error "Unknown CPU architecture"
 #endif
@@ -81,7 +85,7 @@
 #define _PR_POLL_AVAILABLE
 #endif
 #else
-#if __FreeBSD_version >= 300000
+#if __FreeBSD_version >= 300000 || defined(__DragonFly__)
 #define _PR_POLL_AVAILABLE
 #define _PR_USE_POLL
 #endif
@@ -90,7 +94,7 @@
 #define _PR_HAVE_SYSV_SEMAPHORES
 #define PR_HAVE_SYSV_NAMED_SHARED_MEMORY
 
-#if __FreeBSD_version >= 400014
+#if __FreeBSD_version >= 400014 || defined(__DragonFly__)
 #define _PR_INET6
 #define _PR_HAVE_INET_NTOP
 #define _PR_HAVE_GETHOSTBYNAME2
